//---------------------------------------------------------------------------
//	Greenplum Database
//	Copyright (C) 2014 Pivotal Inc.
//
//	@filename:
//		CParseHandlerScalarPartBound.h
//
//	@doc:
//		SAX parse handler class for parsing scalar part bound
//---------------------------------------------------------------------------

#ifndef GPDXL_CParseHandlerScalarScalarPartBound_H
#define GPDXL_CParseHandlerScalarScalarPartBound_H

#include "gpos/base.h"
#include "naucrates/dxl/parser/CParseHandlerScalarOp.h"

namespace gpdxl
{
	using namespace gpos;

	XERCES_CPP_NAMESPACE_USE

	//---------------------------------------------------------------------------
	//	@class:
	//		CParseHandlerScalarPartBound
	//
	//	@doc:
	//		Parse handler class for parsing scalar part bound
	//
	//---------------------------------------------------------------------------
	class CParseHandlerScalarPartBound : public CParseHandlerScalarOp
	{
		private:

			// private copy ctor
			CParseHandlerScalarPartBound(const CParseHandlerScalarPartBound&);

			// process the start of an element
			void StartElement
				(
					const XMLCh* const xmlszUri, 		// URI of element's namespace
 					const XMLCh* const xmlszLocalname,	// local part of element's name
					const XMLCh* const xmlszQname,		// element's qname
					const Attributes& attr				// element's attributes
				);

			// process the end of an element
			void EndElement
				(
					const XMLCh* const xmlszUri, 		// URI of element's namespace
					const XMLCh* const xmlszLocalname,	// local part of element's name
					const XMLCh* const xmlszQname		// element's qname
				);

		public:
			// ctor
			CParseHandlerScalarPartBound
				(
				IMemoryPool *pmp,
				CParseHandlerManager *pphm,
				CParseHandlerBase *pphRoot
				);
	};
}

#endif // !GPDXL_CParseHandlerScalarScalarPartBound_H

// EOF
