//---------------------------------------------------------------------------
//	Greenplum Database
//	Copyright (C) 2011 Greenplum, Inc.
//
//	@filename:
//		CParseHandlerSort.h
//
//	@doc:
//		SAX parse handler class for parsing sort operator nodes.
//---------------------------------------------------------------------------

#ifndef GPDXL_CParseHandlerSort_H
#define GPDXL_CParseHandlerSort_H

#include "gpos/base.h"
#include "naucrates/dxl/parser/CParseHandlerPhysicalOp.h"

#include "naucrates/dxl/operators/CDXLPhysicalSort.h"

namespace gpdxl
{
	using namespace gpos;

	XERCES_CPP_NAMESPACE_USE
	
	//---------------------------------------------------------------------------
	//	@class:
	//		CParseHandlerSort
	//
	//	@doc:
	//		Parse handler for sort operators
	//
	//---------------------------------------------------------------------------
	class CParseHandlerSort : public CParseHandlerPhysicalOp
	{
		private:

			// the sort operator
			CDXLPhysicalSort *m_pdxlop;
			
			// private copy ctor
			CParseHandlerSort(const CParseHandlerSort &);

			// process the start of an element
			void StartElement
				(
					const XMLCh* const xmlszUri, 		// URI of element's namespace
 					const XMLCh* const xmlszLocalname,	// local part of element's name
					const XMLCh* const xmlszQname,		// element's qname
					const Attributes& attr				// element's attributes
				);
				
			// process the end of an element
			void EndElement
				(
					const XMLCh* const xmlszUri, 		// URI of element's namespace
					const XMLCh* const xmlszLocalname,	// local part of element's name
					const XMLCh* const xmlszQname		// element's qname
				);
			
		public:
			// ctor/dtor
			CParseHandlerSort
				(
				IMemoryPool *pmp,
				CParseHandlerManager *pphm,
				CParseHandlerBase *pphRoot
				);			
	};
}

#endif // !GPDXL_CParseHandlerSort_H

// EOF
