-- Licensed to the Apache Software Foundation (ASF) under one
-- or more contributor license agreements.  See the NOTICE file
-- distributed with this work for additional information
-- regarding copyright ownership.  The ASF licenses this file
-- to you under the Apache License, Version 2.0 (the
-- "License"); you may not use this file except in compliance
-- with the License.  You may obtain a copy of the License at
--
--   http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing,
-- software distributed under the License is distributed on an
-- "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
-- KIND, either express or implied.  See the License for the
-- specific language governing permissions and limitations
-- under the License.
--
-- Adjust this setting to control where the objects get created.

CREATE SCHEMA workfile;
SET search_path = workfile;

BEGIN;

-- Register the functions.
     
CREATE OR REPLACE FUNCTION gp_workfile_mgr_test(testname text)
RETURNS setof bool
AS '$libdir/gp_workfile_mgr', 'gp_workfile_mgr_test_harness_wrapper' LANGUAGE C IMMUTABLE;

CREATE FUNCTION gp_workfile_mgr_test_allsegs(testname text)
RETURNS SETOF BOOL
AS
$$
 SELECT C.* FROM gp_dist_random('gp_version_at_initdb'), workfile.gp_workfile_mgr_test($1) as C
 UNION ALL
 SELECT C.* FROM gp_version_at_initdb, workfile.gp_workfile_mgr_test($1) as C;
$$
LANGUAGE SQL;

COMMIT;
